import { useEffect, useState } from '@taro-hooks/core';
import { escapeState } from '@taro-hooks/shared';
import useDebounceFn from '../useDebounceFn';
function useDebounce(value, options) {
  var _useState = useState(value),
    debounced = _useState[0],
    setDebounced = _useState[1];
  var debounceFn = useDebounceFn(function () {
    setDebounced(value);
  }, options);
  useEffect(function () {
    escapeState(debounceFn).run();
  }, [value]);
  return debounced;
}
export default useDebounce;